(* Example for use of DPMI-Calls to serve a hardware interrupt
   from COMx.
   For other devices the following routines in Unit "IntDemo"
   have to be changed:
     InitIRQ    (enable interrupt from device)
     ReleaseIRQ (disable interrupt from device)
     RMInt      (interrupt service routine)

   J. Rathlev, Uni-Kiel, Apr. 1998
   *)
unit DpmiMain;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, IntDemo, DPMI;

const
  (* Values are for non standard COM *)
  PortAdr = $238;
  IRQNr = 5;

type
  TMainForm = class(TForm)
    IRQCount: TEdit;
    Start: TButton;
    Quit: TButton;
    Label1: TLabel;
    Label2: TLabel;
    ShowChar: TEdit;
    procedure StartClick(Sender: TObject);
    procedure QuitClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckMessages(var Msg: TMsg; var Handled: Boolean);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

(* enable IRQ *)
procedure TMainForm.StartClick(Sender: TObject);
var
  err : word;
begin
  err:=InitIRQ(PortAdr,IRQNr,Handle);
  if err<>errOK then ShowMessage ('Init-Error: '+IntToStr(err));
  IRQCount.Text:=IntToStr(IRQCnt);
end;

procedure TMainForm.QuitClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  ReleaseIRQ;
end;

(* define OnMessage-Event *)
procedure TMainForm.FormCreate(Sender: TObject);
begin
  Application.OnMessage:=CheckMessages;
end;

(* OnMessage-Event for application *)
procedure TMainForm.CheckMessages(var Msg: TMsg; var Handled: Boolean);
begin
  with Msg do if message=wmCharReceived then begin
    IRQCount.Text:=IntToStr(lparam); (* update display *)
    ShowChar.Text:=chr(wparam);
    end;
  end;


end.
